#include "TextTool.h"

#include <fstream>
#include <stdarg.h>

using namespace std;

namespace HPL {
namespace General {
namespace TextTool {
/**
  *
  */
int load_StringLinesFromFile( const char* lpszFilePath,
	std::vector<std::string>* pvecOut) 
{
	// pvecOut̏͂Ȃ
	if( pvecOut == NULL ) {
		_ASSERT( 0 );
		return ErrorType::ERR_PARAM;
	}

	// I[v
	ifstream ifs( lpszFilePath );

	if( ifs.is_open() == false ) {
		// I[vs
		_ASSERT(0);
		// TODO exception𓊂
		return ErrorType::ERR_IO;
	}

	// i[pobt@TCY
	const int BUFFER_SIZE = 1024;

	// i[pobt@
	char lpszBuffer[ BUFFER_SIZE ];

	
	while( ifs.getline( lpszBuffer, BUFFER_SIZE ) ) {
		// stringɕϊ
		string line( lpszBuffer );

		// i[
		pvecOut->push_back( line );
	}

	ifs.close();

	return ErrorType::ERR_NONE;
}
/** t@C݂̑̐mF
  * @param[in]	lpszFilePath	t@CpX
  * @retval		true			݂
  */
bool isExists( const char* lpszFilePath ) {
	ifstream ifs( lpszFilePath );
	if( ifs.is_open() ) {
		ifs.close();
		return true;
	}
	return false;
}

/**
  *
  */
bool is_SkipLine( string& strLine ) {

	return strLine.compare("") == 0 ||
		strLine.at(0) == ';' ||
		strLine.at(0) == '#';
}

std::string get_String( const char* format, ... ) {
	const int BUFFER_MAX = 1024;
	char message[BUFFER_MAX];

	va_list maker;
	va_start( maker, format );
	vsprintf_s( message, BUFFER_MAX, format, maker );
	std::string str( message );
	return str;
}
std::vector<std::string> split( std::string& strIn, const char* lpczSeparator ){
	std::vector<std::string> arrays;

	int sepLength = strlen( lpczSeparator );

	for(int i = 0; i < static_cast<int>(strIn.length()); i ++){

		// ̃Zp[^̈ʒu擾
		int pos = strIn.find( lpczSeparator, i);

		
		if(pos == std::string::npos){
			// ŌɒB

			// Ō̗vfFinish
			arrays.push_back( strIn.substr( i ) );
			break;

		}else if(pos == i){
			// Zp[^JԂĂ
			// XLbv܂
			i = pos + sepLength - 1;
		}else {
			// ÕZp[^̈ʒu or ŏ̈ʒuÃZp[^܂ł̈ʒu؂oAzɒǉ
			arrays.push_back( strIn.substr( i, pos - i) );
			i = pos + sepLength - 1;
		}
	}
	return arrays;
}
}
}
}